
import 'dart:async';

import 'package:flutter/services.dart';

class AddonsPlugin {
  static const MethodChannel _channel = MethodChannel('addons_plugin');

  static Future<String?> get platformVersion async {
    final String? version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<String?> get checkInternet async {
    final String? version = await _channel.invokeMethod('checkInternet');
    return version;
  }

  static Future<String?> get getUniqueNumber async {
    final String? version = await _channel.invokeMethod('UniqueNumber');
    return version;
  }

  static Future<String?> get openDateSettings async {
    final String? version = await _channel.invokeMethod('openDateSettings');
    return version;
  }

  Future<String> encodeData(String details, String key, String iv) async {
    final String version = await _channel
        .invokeMethod('encodeData', {'details': details, 'key': key, 'iv': iv});

    return version;
  }

  Future<String> decodeData(String details, String key, String iv) async {
    final String version = await _channel
        .invokeMethod('decodeData', {'details': details, 'key': key, 'iv': iv});

    return version;
  }

  Future<String> reEncryption(String details, String key, String iv) async {
    final String version = await _channel.invokeMethod(
        'RE_Encryption', {'details': details, 'key': key, 'iv': iv});

    return version;
  }

  Future<String> reDescription(String details, String key, String iv) async {
    final String version = await _channel.invokeMethod(
        'RE_Description', {'details': details, 'key': key, 'iv': iv});

    return version;
  }

  Future<String> checkBarCode(String code) async {
    final String version =
    await _channel.invokeMethod('checkBarCode', {'code': code});

    return version;
  }

  Future<String> checkPermission(String plateform) async {
    if (plateform.toLowerCase() == "IOS".toLowerCase()) {
      return "not allowd";
    }

    final String version = await _channel.invokeMethod('checkPermission');
    return version;
  }
}
